      PROGRAM glmswin
C Program to generate a widget made of two columns, to get user settings
C for GLMS. These settings are written to "GLMS.IN" and then GLMS is run.
c This is version 1.0
      common /mycom1/ id_nstep,id_minlam,id_maxlam,id_lamchoice,
     +  ilamchoice,
     +  id_lfixed,id_modelchoice,id_stop,id_maxit,id_boot,id_seed,model
      common /mycom2/ lamchoice,modelchoice
      PARAMETER (NMAX=10000)
      real*4 lnlam(nmax),nparam(nmax),gcvf(nmax),ocvf(nmax),
     +  gcvf_min,gcvf_max,ocvf_min,ocvf_max,lamstep,gcvstep,
     +  X(nmax),Y(nmax),YHAT(nmax),YPRED(nmax),ymin,ymax,ystep,xstep,
     +  Yminus(nmax),Yplus(nmax),tmp1
      CHARACTER*50 lamchoice,modelchoice,strucchoice,covchoice
      character*100 infile,outfile,wd,systemcommand
      character*10 testread,astep
	integer ifroma,nstep,icol,model,ilamchoice,M,catcov,icov
      character*10 apar,afromi,almin,almax,amaxit,astop,aboot,arandom
      logical hereiam
      EXTERNAL ACTIVATE
      EXTERNAL MODELCHANGE

      lamchoice='fixed lambda|range of lambdas'
      modelchoice='normal|binomial|Poisson'
      covchoice='none|continuous|category'
      strucchoice='Y X [C] N|Y X [C]'

c Get current working directory
      CALL GetCWD(wd,i)

      apar='10'
      M=0
      catcov=0
      nstep=21
      almin='-10'
      almax=' 10'
      amaxit='5'
      astop='0.005'
      model=2
      icol=2
      aboot='0'
      arandom='2387498'
      infile='demo1.dat'
      outfile='glms.out'
      inquire(file='glms.in', exist=hereiam)
      if(hereiam) then
        open (7,file='GLMS.IN')
        read(7,'(a10)',err=20) apar
        read(7,*,err=20) M
        read(7,*,err=20) catcov
        read(7,*,err=20) nstep
        read(7,'(a10)',err=20) almin
        read(7,'(a10)',err=20) almax
        read(7,'(a10)',err=20) amaxit
        read(7,'(a10)',err=20) astop
        read(7,*,err=20) model
        read(7,*,err=20) icol
        read(7,'(a10)',err=20) aboot
        read(7,'(a10)',err=20) arandom
        read(7,'(a50)',err=20) infile
        close(7)
      endif
	goto 30
20    write(*,*) 'Error reading GLMS.IN'
      write(*,*) 'Delete GLMS.IN and start again'
      pause
      goto 999
30    continue
      if(nstep.lt.1) nstep=1
      astep=afromi(nstep)
      if(nstep.eq.1) then
        ilamchoice=1
      else
        ilamchoice=2
      endif
      if(M.eq.0) then
        icov=1
      elseif(catcov.eq.0) then
        icov=2
      else
        icov=3
      endif
c -Make widget--------------------------------------------------------
50    CALL SWGTIT ('User settings for GLMS')
      call swgwth(35)
      call swgpop('NOHELP')
      CALL WGINI ('HORI', ID_mainwidg)
      CALL WGBAS (ID_mainwidg, 'VERT', ID_leftcol)
      CALL WGBAS (ID_mainwidg, 'VERT', ID_rightcol)

C Create a list [or box] widget to get lambda option (1=fixed lambda, 2=grid search)
      CALL WGLAB (ID_leftcol, 'Program option:', ID)
      CALL WGLIS (ID_leftcol, lamchoice, ilamchoice, ID_lamchoice)

C Create a list [or box] widget to get model option (1=normal, 2=etc)
      CALL WGLAB (ID_rightcol, 'Model:', ID)
      CALL WGLIS (ID_rightcol, modelchoice, model, ID_modelchoice)

      CALL WGLAB (ID_rightcol, 'Covariate information:', ID)
      CALL WGLIS (ID_rightcol, covchoice, icov, ID_covchoice)

c Create infile widget
      CALL WGLAB (ID_rightcol, 'Data file name:', ID)
      CALL WGFIL (ID_rightcol, 'Change data file', infile, '*.*',
     +            ID_infile)

      CALL WGLAB (ID_rightcol, 'Data file structure:', ID)
      CALL WGLIS (ID_rightcol, strucchoice, icol, ID_strucchoice)

      CALL WGLTXT (ID_leftcol, 'Enter fixed lambda',
     +      almin, 20, ID_lfixed)
	if(ilamchoice.eq.1) then
        CALL WGLTXT (ID_leftcol, 
     +       'Smallest lambda of range', '-10', 20, ID_minlam)
	else
        CALL WGLTXT (ID_leftcol, 
     +       'Smallest lambda of range', almin, 20, ID_minlam)
	endif
      CALL WGLTXT (ID_leftcol, 
     +       'Largest lambda of range', almax, 20, ID_maxlam)

      if(ilamchoice.eq.2) then
        CALL WGLTXT (ID_leftcol, 
     +      'Number of lambdas in range', astep, 20, ID_nstep)
        CALL WGLTXT (ID_leftcol, 'No. bootstrap replicates',
     +       aboot, 20, ID_boot)
        CALL WGLTXT (ID_leftcol, 'Random number seed',
     +       arandom, 30, ID_seed)
        call swgatt(id_lfixed,'inactive','status')
        call swgatt(id_nstep,'active','status')
        call swgatt(id_minlam,'active','status')
        call swgatt(id_maxlam,'active','status')
        call swgatt(id_boot,'inactive','status')
        call swgatt(id_seed,'inactive','status')
      else
        CALL WGLTXT (ID_leftcol, 
     +      'Number of lambdas in range', '21', 20, ID_nstep)
        CALL WGLTXT (ID_leftcol, 'No. bootstrap replicates',
     +       aboot, 20, ID_boot)
        CALL WGLTXT (ID_leftcol, 'Random number seed',
     +       arandom, 30, ID_seed)
        call swgatt(id_lfixed,'active','status')
        call swgatt(id_nstep,'inactive','status')
        call swgatt(id_minlam,'inactive','status')
        call swgatt(id_maxlam,'inactive','status')      
        call swgatt(id_boot,'active','status')
        call swgatt(id_seed,'active','status')
      endif
C Callback routine deactivates/activates widgets if Method is changed
      CALL SWGCBK (ID_lamchoice, ACTIVATE)

      CALL WGLAB (ID_rightcol,
     +    'Binomial/Poisson glm settings:', ID)
      CALL WGLTXT (ID_rightcol, 'convergence tolerance',
     +     astop, 20, ID_stop)
      CALL WGLTXT (ID_rightcol, 'maximum no. iterations', 
     +     amaxit, 20, ID_maxit)
      if(model.eq.1) then
        call swgatt(id_stop,'inactive','status')
        call swgatt(id_maxit,'inactive','status')
      else
        call swgatt(id_stop,'active','status')
        call swgatt(id_maxit,'active','status')
      endif
c Callback routine deactivates/activates widgets if Model is changed
      CALL SWGCBK (ID_modelchoice, MODELCHANGE)

c Create outfile widget
      CALL WGLAB (ID_leftcol, 'Output file name:', ID)
      CALL WGTXT (ID_leftcol, outfile, ID_outfile)

      CALL WGOK (ID_leftcol, ID_OK)
      CALL WGQUIT (ID_leftcol, ID_OK)

      CALL WGFIN
c -End make widget-----------------------------------------------------

c -Create GLMS.IN and run GLMS-----------------------------------------
c Change working directory back to glms (opening a new data file changes it)
      CALL ChDir(wd,i)
      OPEN (6,FILE='glms.in')
      write(6,'(a,a,a)') apar, 'SAVE FIRST 10 COLUMNS OF THIS ',
     +              'FILE FOR PARAMETERS ONLY'
      call GWGLIS (ID_covchoice,icov)
      if(icov.eq.1) then
        M=0
        catcov=0
      elseif(icov.eq.2) then
        M=1
        catcov=0
      else
        M=1
        catcov=1
      endif
      write(6,*) M, 
     +  '        M = number of covariates (0 or 1)'
      write(6,*) catcov, 
     +  '        catcov = covariate is continuous (0) or category (1)'
      if(ilamchoice.eq.1) then
        astep='1'
        write(6,'(a,a)') astep,
     +  'nstep = number of lambdas to search over'
        call gwgtxt(id_lfixed,almin)
          write(6,'(a,a)') almin, 
     +      'lmin = smallest ln(lambda) of search, or fixed ln(lambda)'
c         almax=almin
          write(6,'(a,a)') almax, 
     +      'lmax = largest ln(lambda) of search'
      else
        call gwgtxt(id_nstep,astep)
        write(6,'(a,a)') astep, 
     +    'nstep = number of lambdas to search over'
        call gwgtxt(id_minlam,almin)
          write(6,'(a,a)') almin, 
     +      'lmin = smallest ln(lambda) of search, or fixed ln(lambda)'
        call gwgtxt(id_maxlam,almax)
          write(6,'(a,a)') almax, 
     +      'lmax = largest ln(lambda) of search'
      endif
      call gwgtxt(id_maxit,amaxit)
        write(6,'(a,a)') amaxit, 
     +    'maxit = max number of iterations for spline fit'
      call gwgtxt(id_stop,astop)
        write(6,'(a,a)') astop, 
     +    'stop = convergence tolerance for spline fit'
      CALL GWGLIS (ID_modelchoice, model)
        write(6,*) model, 
     +    '        model 1 = normal 2= binomial 3=poisson'
      CALL GWGLIS (ID_strucchoice, icol)
        write(6,*) icol, 
     +    '        icol 1 =third data column has #replicates, 2=not'
      call gwgtxt(id_boot,aboot)
      if(ilamchoice.eq.2) aboot='0'
        write(6,'(a,a)') aboot, 
     +    'iboot = Number of bootstrap replications to carry out'
      call gwgtxt(id_seed,arandom)
        write(6,'(a,a)') arandom, 'random number seed for bootstrapping'
c Read infile name
      call gwgfil(id_infile,infile)
81    if(infile(1:1).eq.' ') then
        infile=infile(2:100)
        goto 81
      endif
      write(6,'(a)') infile
      call gwgtxt(id_outfile,outfile)
82    if(outfile(1:1).eq.' ') then
        outfile=outfile(2:100)
        goto 82
      endif
      close(6)

      inquire(file='glms.out', exist=hereiam)
      if(hereiam) CALL SYSTEM ('del glms.out')
      CALL SYSTEM ('glms40.exe < glms.in')

      open(7,file='glms.out')
c	CALL SYSTEM ('pause')
c -End create GLMS.IN/run GLMS-----------------------------------------      

c -Read and plot output------------------------------------------------
      if(ilamchoice.eq.2) then
c     grid search alternative
c ---------------------------
        do 100 i=1,20
          read(7,'(a)') testread
          if(index(testread,'ln(lambd').gt.0) goto 110
100     continue
        goto 999
110     if(M.gt.0) then
          DO 120 I=1,NMAX+1
            READ (7,*,END=150) lnlam(i),nparam(i),gcvf(i)
            if(i.eq.1) then
              gcvf_min=gcvf(i)
              gcvf_max=gcvf(i)
            else
              if(gcvf(i).lt.gcvf_min) gcvf_min=gcvf(i)
              if(gcvf(i).gt.gcvf_max) gcvf_max=gcvf(i)
            endif
120       CONTINUE
        else
          DO 130 I=1,NMAX+1
            READ (7,*,END=150) lnlam(i),nparam(i),gcvf(i),ocvf(i)
            if(i.eq.1) then
              gcvf_min=gcvf(i)
              gcvf_max=gcvf(i)
              ocvf_min=ocvf(i)
              ocvf_max=ocvf(i)
            else
              if(gcvf(i).lt.gcvf_min) gcvf_min=gcvf(i)
              if(gcvf(i).gt.gcvf_max) gcvf_max=gcvf(i)
              if(ocvf(i).lt.ocvf_min) ocvf_min=ocvf(i)
              if(ocvf(i).gt.ocvf_max) ocvf_max=ocvf(i)
            endif
130       CONTINUE
        endif
150     N=I-1
        if(M.eq.0) then
          gcvf_min=min(gcvf_min,ocvf_min)
          gcvf_max=max(gcvf_max,ocvf_max)
        endif
        gcvstep=(gcvf_max-gcvf_min)/5
        lamstep=(lnlam(n)-lnlam(1))/5
	  gcvf_min=gcvf_min-(gcvf_max-gcvf_min)/20
	  gcvf_max=gcvf_max+(gcvf_max-gcvf_min)/20

        DO 190 i=1,2
          call setupplot(i)
          CALL NAME('ln(lambda)','X')
          CALL NAME('Score','Y')
          CALL TITLIN('Range of lambdas',1)
          if(M.eq.0) then
            CALL TITLIN('GCV score (solid) and OCV score (dotted)',3)
          else
            CALL TITLIN('GCV score',3)
          endif
          CALL GRAF(lnlam(1),lnlam(n),lnlam(1),lamstep,
     +                  gcvf_min,gcvf_max,gcvf_min,gcvstep)
          CALL TITLE
          CALL CURVE(lnlam,gcvf,N)
          if(M.eq.0) then
            CALL DASH
            CALL CURVE(lnlam,ocvf,N)
          endif
190     CALL DISFIN

c ---------------------------
c     fixed lambda option, no bootstraps
	else if(aboot.eq.'0') then

        do 200 i=1,20
          read(7,'(a)') testread
          if(index(testread,'        Y').gt.0) goto 210
200     continue
        goto 999
210     DO 220 I=1,NMAX+1
          if(M.gt.0) then
            READ (7,*,END=250) Y(i),X(i),tmp1,j,YPRED(i),YHAT(i)
          else
            READ (7,*,END=250) Y(i),X(i),j,YHAT(i)
          endif
	    if(i.eq.1) then 
	      ymin=y(i)
	      ymax=y(i)
	    else
            if(Y(i).lt.ymin) ymin=Y(i)
            if(YHAT(i).lt.ymin) ymin=YHAT(i)
            if(Y(i).gt.ymax) ymax=Y(i)
            if(YHAT(i).gt.ymax) ymax=YHAT(i)
            if(M.gt.0) then
              if(YPRED(i).lt.ymin) ymin=YPRED(i)
              if(YPRED(i).gt.ymax) ymax=YPRED(i)
            endif
	    endif
220     CONTINUE
250     N=I-1
        ystep=(ymax-ymin)/5
        xstep=(X(N)-X(1))/5

        do 260 i=1,2
          call setupplot(i)
          CALL NAME('Trait (X)','X')
          CALL NAME('Fitness (Yhat)','Y')
          if(M.eq.0) then
            CALL NAME('Fitness (Yhat)','Y')
            CALL TITLIN('Fitness function with data points',1)
          else
            CALL NAME('Corrected fitness (YhatC)','Y')
            CALL TITLIN('Fitness function corrected for covariate',1)
            CALL TITLIN('Symbols are uncorrected predicted values',3)
          endif
          CALL GRAF(X(1)-xstep/10.,X(n)+xstep/10.,X(1),xstep,
     *              ymin-ystep/10.,ymax+ystep/10.,ymin,ystep)
          CALL TITLE
	    CALL CURVE(X,YHAT,N)
          CALL INCMRK (-1)
          CALL HSYMBL (20)
          if(M.gt.0) then
	      CALL CURVE(X,YPRED,N)
          else
	      CALL CURVE(X,Y,N)
          endif
260     CALL DISFIN
c ---------------------------
c     fixed lambda option with bootstraps
	else
        do 300 i=1,20
          read(7,'(a)') testread
          if(index(testread,'      Y').gt.0) goto 310
300     continue
        goto 999
310     DO 320 I=1,NMAX+1
          READ (7,*,END=350) Y(i),X(i),YHAT(i),Yminus(i),Yplus(i)
	    if(i.eq.1) then 
	      ymin=y(i)
	      ymax=y(i)
	    else
            if(Y(i).lt.ymin) ymin=Y(i)
            if(Y(i).gt.ymax) ymax=Y(i)
	    endif
320     CONTINUE
350     N=I-1
        ystep=(ymax-ymin)/5
        xstep=(X(N)-X(1))/5

        do 360 i=1,2
          call setupplot(i)
          CALL NAME('Trait (X)','X')
          if(M.eq.0) then
            CALL NAME('Fitness (Yhat)','Y')
            CALL TITLIN('Fitness function with data points',1)
          else
            CALL NAME('Corrected fitness (YhatC)','Y')
            CALL TITLIN('Fitness function corrected for covariate',1)
          endif
          CALL TITLIN
     *    ('dotted lines are +/- 1 standard error of prediction',3)
          CALL GRAF(X(1)-xstep/10.,X(n)+xstep/10.,X(1),xstep,
     *              ymin-ystep/10.,ymax+ystep/10.,ymin,ystep)
          CALL TITLE
          CALL CURVE(X,YHAT,N)
          CALL DASHL
          CALL CURVE(X,Yminus,N)
	    CALL CURVE(X,Yplus,N)
          CALL INCMRK (-1)
          CALL HSYMBL (20)
	    CALL CURVE(X,Y,N)
360     CALL DISFIN
      endif
c -End read and plot output--------------------------------------------

      close(7)
      if(outfile.ne.'glms.out') then
        systemcommand='type glms.out > '//outfile
        CALL SYSTEM(systemcommand)
      endif
      GOTO 50
999   continue
      END

      SUBROUTINE ACTIVATE (ID)
      common /mycom1/ id_nstep,id_minlam,id_maxlam,id_lamchoice,
     +  ilamchoice,
     +  id_lfixed,id_modelchoice,id_stop,id_maxit,id_boot,id_seed,model
      common /mycom2/ lamchoice,modelchoice
      integer model
      character*50 lamchoice,modelchoice
      CALL GWGLIS (ID_lamchoice, ilamchoice)
      if(ilamchoice.eq.2) then
        call swgatt(id_lfixed,'inactive','status')
        call swgatt(id_nstep,'active','status')
        call swgatt(id_minlam,'active','status')
        call swgatt(id_maxlam,'active','status')
        call swgatt(id_boot,'inactive','status')
        call swgatt(id_seed,'inactive','status')
      else
        call swgatt(id_lfixed,'active','status')
        call swgatt(id_nstep,'inactive','status')
        call swgatt(id_minlam,'inactive','status')
        call swgatt(id_maxlam,'inactive','status')      
        call swgatt(id_boot,'active','status')
        call swgatt(id_seed,'active','status')
      endif
      end

      SUBROUTINE MODELCHANGE (ID)
      common /mycom1/ id_nstep,id_minlam,id_maxlam,id_lamchoice,
     +  ilamchoice,
     +  id_lfixed,id_modelchoice,id_stop,id_maxit,id_boot,id_seed,model
      common /mycom2/ lamchoice,modelchoice
      character*50 lamchoice,modelchoice
      integer model
      CALL GWGLIS (ID_modelchoice,model)
      if(model.eq.1) then
        call swgatt(id_stop,'inactive','status')
        call swgatt(id_maxit,'inactive','status')
      else
        call swgatt(id_stop,'active','status')
        call swgatt(id_maxit,'active','status')
      endif
      end

      SUBROUTINE SETUPPLOT(I)
      integer i
      logical hereiam
      if(i.eq.1) then
 	  CALL METAFL('xwin')
      else
        inquire(file='glms.wmf', exist=hereiam)
        if(hereiam) CALL SYSTEM ('del glms.wmf')
 	  CALL METAFL('wmf')
 	  CALL SETFIL('glms.wmf')
      endif
      CALL SETPAG('DA4L')
      CALL DISINI
      CALL PAGERA
	CALL HEIGHT(40)
	CALL HNAME(40)
	CALL WINFNT('Arial')
      CALL AXSPOS(450,1800)
      CALL AXSLEN(2200,1200)
      CALL LABDIG(3,'XY')
      CALL TICKS(5,'XY')
      return
      end

	character*10 function afromi(i)
	INTEGER i
	CHARACTER*10 string
	write(string,*) i
	afromi=string
	return
	END

	INTEGER function ifroma(string)
	integer value
	CHARACTER*10 STRING
	READ (STRING, '(I10)'), VALUE
	ifroma=value
	return
	END